unit UnMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.StdCtrls, Vcl.ComCtrls, Vcl.Menus
//-- this project --------------------
  , utlZoomText
  , utlZoomStat
  ;

type
  TFmMain = class(TForm)
    Panel1: TPanel;
    TrackBar1: TTrackBar;
    ComboBox1: TComboBox;
    Edit1: TEdit;
    pb: TPaintBox;
    Label10: TLabel;
    Edit2: TEdit;
    StatusBar1: TStatusBar;
    Button1: TButton;
    CheckBox2: TCheckBox;
    PopupMenu1: TPopupMenu;
    G1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure pbPaint(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure G1Click(Sender: TObject);
    procedure pbMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure pbMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure pbMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    FList : TxZoomStatList;
    FListPoint : TPoint;
    FMouseDown : boolean;
    FMousePoint: TPoint;
    FProcessing : boolean;
  public
    //**************************************************************************
    //   -  
    //**************************************************************************    
    function GetCurrFunc (var obj :TxDrawZoomFunc) : boolean;
  end;

var
  FmMain: TFmMain;

implementation
uses math;

{$R *.dfm}

procedure TFmMain.FormCreate(Sender: TObject);
var i : Integer;
begin
  FList := xGZoomList(true);
  for i := 0 to GDrawZoomFuncList.Count-1 do 
    FList.Add(i,GDrawZoomFuncList[i],0,0);

  GDrawZoomFuncList.AddObject('', TObject(@DrawZoomStatList));
  ComboBox1.Items.Assign(GDrawZoomFuncList);
  ComboBox1.ItemIndex := 0;
  Height := 573;
  Width := 1050;
end;

procedure TFmMain.FormDestroy(Sender: TObject);
begin
  FList.Free;
end;

procedure TFmMain.FormShow(Sender: TObject);
begin
//
end;

procedure TFmMain.Button1Click(Sender: TObject);
var idx : Integer;
    sgn : Integer;
//------------------------------------------------------------------------------
  function prepareMix : Integer;
  begin
    idx := ComboBox1.ItemIndex + sgn;
    if idx >= ComboBox1.Items.Count-1 then begin
      sgn := -1;
      idx := ComboBox1.ItemIndex + sgn;
    end; 
    if idx < 0 then begin
      sgn := 1;
      idx := ComboBox1.ItemIndex + sgn;
    end; 
    result := idx;
  end;
//------------------------------------------------------------------------------
var i : Integer;
    j : Integer;
begin
  if FProcessing then begin
    FProcessing := false;
    exit;
  end;
  
  FList.OffX := 0; 
  FList.OffY := 0;
  FProcessing := true;
  sgn := 1;
  Button1.Caption := 'Stop';  
  
  for i := 0 to ComboBox1.Items.Count - 2 do begin
    ComboBox1.ItemIndex := i;  
    for j := TrackBar1.Min to TrackBar1.Max do begin
      if CheckBox2.Checked then 
        ComboBox1.ItemIndex := prepareMix;        
      TrackBar1.Position := J;
      Application.ProcessMessages;  
      if not FProcessing then break;    
    end;
    for j := TrackBar1.Max downto TrackBar1.Min do begin
      if CheckBox2.Checked then
        ComboBox1.ItemIndex := prepareMix;        
      TrackBar1.Position := J;
      Application.ProcessMessages;
      if not FProcessing then break;      
    end;
    Application.ProcessMessages;
    StatusBar1.Invalidate;
    if not FProcessing then break;
  end;
  ComboBox1.ItemIndex := ComboBox1.Items.Count - 1;    
  TrackBar1.Position := 13;
  FProcessing := false;
  Button1.Caption := 'Start';  
end;

procedure TFmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
//
end;

//**************************************************************************
//   -  
//**************************************************************************    
procedure TFmMain.G1Click(Sender: TObject);
begin
  TMenuItem(Sender).Checked := not TMenuItem(Sender).Checked;
  FList.GDIPlus := TMenuItem(Sender).Checked;
  pbPaint(Sender);
end;

function TFmMain.GetCurrFunc (var obj :TxDrawZoomFunc) : boolean;
var idx : Integer;
begin
  result := false;
  idx := ComboBox1.ItemIndex;
  if idx < 0 then idx := 0;
  if idx >= ComboBox1.Items.Count then exit;
  obj := TxDrawZoomFunc (ComboBox1.Items.Objects[idx]);
  result := true;
end;

procedure TFmMain.pbMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  FMouseDown := (Button = mbLeft) and 
                //--  -    -----------------
                (ComboBox1.ItemIndex=ComboBox1.Items.Count-1);
  if FMouseDown then begin
    //--  ,    ----------------
    FMousePoint := Point(X,Y);
    //--    ---------------------------------    
    FListPoint := Point(FList.OffX, FList.OffY);
  end;  
end;

procedure TFmMain.pbMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if FMouseDown then begin
    //--    ------------------------------------------
    FList.OffX := FListPoint.X + X-FMousePoint.X; 
    FList.OffY := FListPoint.Y + Y-FMousePoint.Y;    
    //--   -----------------------------------------------
    pbPaint(Sender);
  end;
end;

procedure TFmMain.pbMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
//--   ---------------------
  FMouseDown := false;
end;

procedure TFmMain.pbPaint(Sender: TObject);
var bmp : TBitmap;
    rct : TRect;
    val : double;
    fnc : TxDrawZoomFunc;
    t : integer;
    d : double;
    fct1 : double;
    fct2 : double;    
begin
  if not GetCurrFunc(fnc) then fnc := nil;
  val := StrToFLoatEx(Edit1.Text);
  bmp := CreateBMPRect (pb.ClientRect);
  
  try
    with bmp.Canvas do begin
      Brush.Color := clWhite;
      FillRect (ClipRect);
      rct := ClipRect;
      rct.Left := rct.Left + 10;
      DrawZoomGrid(bmp.Canvas,rct,TrackBar1.Position/10);

      Pen.Color := clBtnShadow;
      Pen.Width := 2;
      MoveTo (rct.Left,rct.Top);
      LineTo (rct.Left,rct.Bottom);      
      
      Brush.Style := bsClear;
      d := now;
      t := GetTickCount;
      
        Font.Name := 'Tahoma';
        Font.Height := -trunc(val * Font.PixelsPerInch / 72);
        rct.Top := rct.Top + 20 - TextHeight('W');
        if assigned (fnc) then begin
          fnc(bmp.Canvas,rct,TrackBar1.Position/10,val,Edit2.Text + '1');
          
          fct1 := GDiffWidth;
          rct.Top := rct.Top + round(1.5*TextHeight('W'));
          if ComboBox1.ItemIndex < ComboBox1.Items.Count-1 then 
            fnc(bmp.Canvas,rct,TrackBar1.Position/10,1.5*val,Edit2.Text + '2');
          fct2 := GDiffWidth;
        end;  
    end;
    
    d := now - d;
    t := GetTickCount - t;
  except
  end;
  pb.Canvas.Draw(0,0,bmp);
  bmp.free;
  d := d * 86400000;
  StatusBar1.Panels[1].Text := FormatFLoat ('#0.000#', d);
  StatusBar1.Panels[2].Text := FormatFLoat ('#0.000#', t);    
  StatusBar1.Panels[3].Text := FormatFLoat ('#0.000#', fct1);    
  StatusBar1.Panels[4].Text := FormatFLoat ('#0.000#', fct2);    

    StatusBar1.Panels[0].Text := '1';
    
  if ComboBox1.ItemIndex < ComboBox1.Items.Count-1 then 
    FList.Add(ComboBox1.ItemIndex,d,fct1);
end;

end.
